// ArsTechnica - Multi-page viewer
// version 0.5
// 2016-11-01
// Copyright (c) 2013-2016, Tostis
// Based on ArsTechnica - Multi-page viewer by Christopher Campbell
// Based on ArsTechnica - Single Page View by Julien Couvreur
// Released under the GPL license
// http://www.gnu.org/copyleft/gpl.html
// --------------------------------------------------------------------
//
// ==UserScript==
// @name            ArsTechnica - Multi-page viewer
// @namespace	http://userscripts.org
// @description    Combines the multi-page articles on ArsTechnica.com/co.uk into single-page views.
// @include     /^https?://*arstechnica\.(com|co\.uk)/.*$/
// @grant GM_xmlhttpRequest
// ==/UserScript==



function createDocument(html) {
  var doc = parseHTML(html);
  doc.documentElement.innerHTML = html;
  return doc;
}

function parseHTML(sText) {
try {
    if (typeof window.DOMParser !=null) {
        var parser = new DOMParser();
        var doc = parser.parseFromString(sText, "text/html");
        if (doc != null) {
            return doc
        }
        else {
            sText = sText.replace(/&/gi, "j!J!");
            var doc = parser.parseFromString(sText, "text/xml");
            return doc;
        }
    } 
    else  {
        doc= document.implementation.createHTMLDocument('');
        doc.write(sText);           
        doc.close;
        return doc; 
    }
} catch (err) {
    alert("Error parsing html:\n" + err.message);
}
}

function getNode(iframeDoc, xpath) {
    var source = iframeDoc.evaluate(xpath, iframeDoc, null,
                                    XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    if (source.snapshotLength > 0) {
        return source.snapshotItem(0);
    }
}

function makeNextUrl(baseUrl, pageNumber) {
    var nextUrl = baseUrl + pageNumber;
    return nextUrl;
}

 function getNextPage(href, pageNumber){
   var loadingHref = makeNextUrl(href, pageNumber);
    GM_xmlhttpRequest({
	    method: 'GET',
	    url: loadingHref,
	    onload: function(responseDetails) {
	      var newPageDocument = createDocument(responseDetails.responseText);
	      var newArticleGuts = getNode(newPageDocument, "//section[@id='article-guts']/div");
	      var lastOldArticleGuts = getNode(document, "//section[@id='article-guts' and last()]/div"); 
	      lastOldArticleGuts.parentNode.insertBefore(newArticleGuts,lastOldArticleGuts.nextSibling);
	      currPage++;
	      if(currPage < totPages)
		getNextPage(href,currPage);
	      else if(currPage == totPages)
		alert('Done loading '+currPage+'/'+totPages+' pages');
	    }
    });
}

var baseUrl = '';
var totPages;
var currPage;

if (document.location.href.match(/^https?:\/\/*arstechnica\.(com|co\.uk)\/.*$/i) != null && document.location.href.match(/^https?:\/\/*arstechnica\.(com|co\.uk)\/ads.*$/i) == null) 
{
    baseUrl = document.location.href;
    currPage=2;
    var lastPage = "//span[@class='numbers']/a[last()-1]";
    var nodeLastPage = getNode(document, lastPage);
	if(nodeLastPage!=null)
	{
		totPages = nodeLastPage.innerHTML;
		var pageNumbersIndex = "//section[@id='article-guts']/nav";
		var pageNumbersIndexNode = getNode(document, pageNumbersIndex);
		pageNumbersIndexNode.parentNode.removeChild(pageNumbersIndexNode);
		getNextPage(baseUrl, currPage);
	}
}


